<script lang="ts" setup>
import {
  JList,
  JListItem,
  JIcon,
  JDivider,
  JText,
  JMenu,
  JThemeIcon,
} from '@new-jira-clone/ui/src/components';
import useTheme from '@new-jira-clone/ui/src/composables/utils/useTheme';
import useChatRouter from 'Chat/router';
import { useLogout } from 'Auth/features/logout';

const { logout } = useLogout();
const { setTheme, getCurrentTheme } = useTheme();

const { getPathConfig: chatPath } = useChatRouter();
</script>

<template>
  <div class="app-menu">
    <JList class="nav-list">
      <JListItem
        size="xl"
        disabled
        tabindex="-1"
        class="nav-list-item"
      >
        <JIcon
          icon="notificationAction"
          size="24px"
        />
        <JText
          color="text"
          weight="normal"
          type="text-4"
          class="list-item-label"
        >
          {{ $t('app_menu_item_project_board') }}
        </JText>
      </JListItem>
      <router-link
        :to="chatPath.chat"
        class="nav-list-link"
        v-slot="{ isActive }"
      >
        <JListItem
          size="xl"
          tabindex="-1"
          :active="isActive"
          class="nav-list-item"
        >
          <JIcon
            size="28px"
            icon="chat"
            container-size
            viewBox="-1 0 24 24"
          />
          <JText
            color="text"
            weight="normal"
            type="text-4"
            class="list-item-label"
          >
            {{ $t('app_menu_item_chat') }}
          </JText>
        </JListItem>
      </router-link>
      <JListItem
        size="xl"
        disabled
        class="nav-list-item"
      >
        <JIcon
          icon="calendar"
          size="24px"
        />
        <JText
          color="text"
          weight="normal"
          type="text-4"
          class="list-item-label"
        >
          {{ $t('app_menu_item_backlog') }}
        </JText>
      </JListItem>
    </JList>

    <JDivider />

    <JList class="nav-list">
      <a
        href="https://jira-ui-storybook.onrender.com/"
        target="_blank"
        class="nav-list-link"
      >
        <JListItem
          size="xl"
          tabindex="-1"
          class="nav-list-item"
        >
          <JIcon
            size="24px"
            icon="storybookLogo"
            container-size
          />
          <JText
            color="text"
            weight="normal"
            type="text-4"
            class="list-item-label"
          >
            UI
          </JText>
        </JListItem>
      </a>
      <JMenu dynamic-position>
        <template #activator="activatorProps">
          <JListItem
            v-bind="activatorProps"
            size="xl"
            class="nav-list-item"
            active
          >
            <JIcon
              icon="themeColor"
              size="24px"
            />
            <JText
              color="primary"
              weight="normal"
              type="text-4"
              class="list-item-label"
            >
              Theme
            </JText>
          </JListItem>
        </template>

        <JList>
          <JListItem
            size="l"
            :active="getCurrentTheme === 'light-blue'"
            class="theme-list-item"
            @click="setTheme('light-blue')"
            @keydown.space="setTheme('light-blue')"
            @keydown.enter="setTheme('light-blue')"
          >
            <JThemeIcon class="theme-icon" />
            <span class="list-item-label">Blue Theme</span>
          </JListItem>
          <JListItem
            size="l"
            :active="getCurrentTheme === 'light-purple'"
            class="theme-list-item"
            @click="setTheme('light-purple')"
            @keydown.space="setTheme('light-purple')"
            @keydown.enter="setTheme('light-purple')"
          >
            <JThemeIcon
              theme="purple"
              class="theme-icon"
            />
            <span class="list-item-label">Purple Theme</span>
          </JListItem>
        </JList>
      </JMenu>
      <JListItem
        size="xl"
        class="nav-list-item"
        @click="logout"
        @keydown.space="logout"
        @keydown.enter="logout"
      >
        <JIcon
          icon="logout"
          size="24px"
        />
        <JText
          color="text"
          weight="normal"
          type="text-4"
          class="list-item-label"
        >
          {{ $t('app_menu_item_logout') }}
        </JText>
      </JListItem>
    </JList>
  </div>
</template>

<style lang="scss" scoped>
@use '@tools' as uiTools;

.app-menu {
  display: flex;
  flex-direction: column;
  align-items: center;
  z-index: 5;
  overflow: hidden;
  transition: 300ms;

  .nav-list {
    display: flex;
    flex-direction: column;
    width: 100%;
    background-color: inherit;
  }

  .nav-list-link {
    &:focus-visible {
      outline: none;
      box-shadow: var(--j-focus-shadow);
    }
  }

  .nav-list-item {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    position: relative;
    width: 100%;
    cursor: pointer;

    &:hover {
      .list-item-label,
      svg {
        color: rgb(var(--j-primary-color));
      }
    }

    svg {
      color: rgb(var(--j-secondary-title-color));
    }
  }
}

.router-link-active {
  display: flex;
  align-items: center;
  position: relative;
  @include uiTools.active-color;

  &::after {
    content: '';
    position: absolute;
    left: 2px;
    width: 3px;
    height: calc(100% - 8px);
    background-color: rgb(var(--j-primary-color));
  }

  .nav-list-item {
    .list-item-label,
    svg {
      color: rgb(var(--j-primary-color));
    }
  }
}

.list-item-label {
  color: rgb(var(--j-secondary-title-color));
}

.theme-icon {
  margin-right: 8px;
  width: 24px;
  height: 24px;
}

.theme-list-item {
  &.active {
    @include uiTools.active-color;
  }
}
</style>
